import common.grid_world as grid_world
from common.config import Config
from matplotlib import animation
import matplotlib.pyplot as plt

def save_frames_as_gif(frames, path='./Gif/', filename='gym_animation.gif'):

    #Mess with this to change frame size
    plt.figure(figsize=(frames[0].shape[1] / 36.0, frames[0].shape[0] / 36.0), dpi=36)

    patch = plt.imshow(frames[0])
    plt.axis('off')

    def animate(i):
        patch.set_data(frames[i])

    anim = animation.FuncAnimation(plt.gcf(), animate, frames = len(frames), interval=50)
    #anim.save(path + filename, writer='imagemagick', fps=60)
    anim.save(path + filename, writer='pillow', fps=60)

def get_env_config(args):
    if args == 'two_way_grid_world':
        env = grid_world.TwoWayGridWorld()
        config = Config(env, 'two_way_grid_world')
    return env, config

env, config = get_env_config('two_way_grid_world')
trajectories = []
act_list = []
file = open('random_demo.txt','r').readlines()
#print (file)
act_ind = 1
frames = []
for ind in range(len(file)):
    if ind == act_ind:
        act = file[ind].strip().split(':')[1]
        act_list.append(int(act))
        act_ind += 3
        if file[ind+1].strip().split(':')[1] == 'True':
            trajectories.append(act_list)
            act_list = []
print (trajectories)
print (len(trajectories))
for tra in trajectories:
    state = env.reset()
    for act in tra:
        #env.step(act)
        env.random_step(act)
        env.render()
        frames.append(env.render(mode='rgb_array'))
gif_name ='random_env_expert_tra.gif'
save_frames_as_gif(frames, filename=gif_name)