import numpy as np


def entropy(state_sum):
    prob_x = state_sum / np.sum(state_sum)
    mid = prob_x * np.log(prob_x)
    where_are_nan = np.isnan(mid)
    mid[where_are_nan] = 0
    en = -sum(mid)
    return en


def softmax(x):
    x = x.astype('float64')
    e_x = np.exp(x - np.max(x))
    softmax_x = e_x / e_x.sum(axis=0)
    return softmax_x
